diff --git a/wcs/admin/settings.py b/wcs/admin/settings.py
index 7e3f364a..65269ab3 100644
--- a/wcs/admin/settings.py
+++ b/wcs/admin/settings.py
@@ -848,12 +848,11 @@ class SettingsDirectory(QommonSettingsDirectory):
 
         parent_theme_directory = os.path.dirname(theme_directory)
         c = io.BytesIO()
-        z = zipfile.ZipFile(c, 'w')
-        for base, dummy, filenames in os.walk(theme_directory):
-            basetheme = base[len(parent_theme_directory) + 1 :]
-            for filename in filenames:
-                z.write(os.path.join(base, filename), os.path.join(basetheme, filename))
-        z.close()
+        with zipfile.ZipFile(c, 'w') as z:
+            for base, dummy, filenames in os.walk(theme_directory):
+                basetheme = base[len(parent_theme_directory) + 1 :]
+                for filename in filenames:
+                    z.write(os.path.join(base, filename), os.path.join(basetheme, filename))
 
         response = get_response()
         response.set_content_type('application/zip')
@@ -896,36 +895,36 @@ class SettingsDirectory(QommonSettingsDirectory):
 
     def install_theme_from_file(self, fp):
         try:
-            z = zipfile.ZipFile(fp, 'r')
+            with zipfile.ZipFile(fp, 'r') as z:
+                theme_dir = os.path.join(get_publisher().app_dir, 'themes')
+                filename_list = [x for x in z.namelist() if x[0] != '/' and x[-1] != '/']
+                if len(filename_list) == 0:
+                    get_session().message = ('error', _('Empty theme file.'))
+                    return redirect('themes')
+                theme_name = filename_list[0].split('/')[0]
+                if ('%s/desc.xml' % theme_name) not in filename_list:
+                    get_session().message = ('error', _('Theme is missing a desc.xml file.'))
+                    return redirect('themes')
+                desc_xml = z.read('%s/desc.xml' % theme_name)
+                theme_dict = template.get_theme_dict(io.StringIO(force_text(desc_xml)))
+                if theme_dict.get('name') != theme_name:
+                    get_session().message = ('error', _('desc.xml is missing a name attribute.'))
+                    return redirect('themes')
+                if os.path.exists(os.path.join(theme_dir, theme_name)):
+                    shutil.rmtree(os.path.join(theme_dir, theme_name))
+                for f in z.namelist():
+                    if f[-1] == '/':
+                        continue
+                    path = os.path.join(theme_dir, f)
+                    data = z.read(f)
+                    if not os.path.exists(os.path.dirname(path)):
+                        os.makedirs(os.path.dirname(path))
+                    with open(path, 'wb') as _f:
+                        _f.write(data)
+                return redirect('themes')
         except Exception as e:
             get_session().message = ('error', _('Failed to read theme file.  (%s)') % str(e))
             return redirect('themes')
-        theme_dir = os.path.join(get_publisher().app_dir, 'themes')
-        filename_list = [x for x in z.namelist() if x[0] != '/' and x[-1] != '/']
-        if len(filename_list) == 0:
-            get_session().message = ('error', _('Empty theme file.'))
-            return redirect('themes')
-        theme_name = filename_list[0].split('/')[0]
-        if ('%s/desc.xml' % theme_name) not in filename_list:
-            get_session().message = ('error', _('Theme is missing a desc.xml file.'))
-            return redirect('themes')
-        desc_xml = z.read('%s/desc.xml' % theme_name)
-        theme_dict = template.get_theme_dict(io.StringIO(force_text(desc_xml)))
-        if theme_dict.get('name') != theme_name:
-            get_session().message = ('error', _('desc.xml is missing a name attribute.'))
-            return redirect('themes')
-        if os.path.exists(os.path.join(theme_dir, theme_name)):
-            shutil.rmtree(os.path.join(theme_dir, theme_name))
-        for f in z.namelist():
-            if f[-1] == '/':
-                continue
-            path = os.path.join(theme_dir, f)
-            data = z.read(f)
-            if not os.path.exists(os.path.dirname(path)):
-                os.makedirs(os.path.dirname(path))
-            open(path, 'wb').write(data)
-        z.close()
-        return redirect('themes')
 
     def install_theme_from_url(self, url):
         try:
@@ -1028,83 +1027,82 @@ class SettingsDirectory(QommonSettingsDirectory):
 
             def export(self, job):
                 c = io.BytesIO()
-                z = zipfile.ZipFile(c, 'w')
-                for d in self.dirs:
-                    if d not in (
-                        'categories',
-                        'carddef_categories',
-                        'wscalls',
-                        'mail-templates',
-                        'apiaccess',
-                    ):
-                        continue
-                    path = os.path.join(self.app_dir, d)
-                    if not os.path.exists(path):
-                        continue
-                    for f in os.listdir(path):
-                        if f in ('.indexes', '.max_id'):
+                with zipfile.ZipFile(c, 'w') as z:
+                    for d in self.dirs:
+                        if d not in (
+                            'categories',
+                            'carddef_categories',
+                            'wscalls',
+                            'mail-templates',
+                            'apiaccess',
+                        ):
                             continue
-                        z.write(os.path.join(path, f), os.path.join(d, f))
-                if 'datasources' in self.dirs:
-                    for ds in NamedDataSource.select():
-                        if ds.external == 'agenda':
+                        path = os.path.join(self.app_dir, d)
+                        if not os.path.exists(path):
                             continue
-                        node = ds.export_to_xml(include_id=True)
-                        misc.indent_xml(node)
-                        z.writestr(
-                            os.path.join('datasources', str(ds.id)),
-                            ET.tostring(node),
-                        )
-                if 'formdefs' in self.dirs:
-                    for formdef in FormDef.select():
-                        node = formdef.export_to_xml(include_id=True)
-                        misc.indent_xml(node)
-                        z.writestr(
-                            os.path.join('formdefs_xml', str(formdef.id)),
-                            b'<?xml version="1.0"?>\n' + ET.tostring(node),
-                        )
-                if 'carddefs' in self.dirs:
-                    for formdef in CardDef.select():
-                        node = formdef.export_to_xml(include_id=True)
-                        misc.indent_xml(node)
-                        z.writestr(
-                            os.path.join('carddefs_xml', str(formdef.id)),
-                            b'<?xml version="1.0"?>\n' + ET.tostring(node),
-                        )
-                if 'workflows' in self.dirs:
-                    for workflow in Workflow.select():
-                        node = workflow.export_to_xml(include_id=True)
-                        misc.indent_xml(node)
-                        z.writestr(
-                            os.path.join('workflows_xml', str(workflow.id)),
-                            b'<?xml version="1.0"?>\n' + ET.tostring(node),
-                        )
-                if 'blockdefs' in self.dirs:
-                    for blockdef in BlockDef.select():
-                        node = blockdef.export_to_xml(include_id=True)
-                        misc.indent_xml(node)
-                        z.writestr(
-                            os.path.join('blockdefs_xml', str(blockdef.id)),
-                            b'<?xml version="1.0"?>\n' + ET.tostring(node),
-                        )
-                if 'roles' in self.dirs:
-                    for role in get_publisher().role_class.select():
-                        node = role.export_to_xml(include_id=True)
-                        misc.indent_xml(node)
-                        z.writestr(
-                            os.path.join('roles_xml', str(role.id)),
-                            b'<?xml version="1.0"?>\n' + ET.tostring(node),
-                        )
-
-                if self.settings:
-                    z.write(os.path.join(self.app_dir, 'config.pck'), 'config.pck')
-                    for f in os.listdir(self.app_dir):
-                        if f.startswith('idp-') and os.path.splitext(f)[-1] in ('.pem', '.xml'):
-                            z.write(os.path.join(self.app_dir, f), f)
-                    if os.path.exists(os.path.join(self.app_dir, 'config')):
-                        for f in os.listdir(os.path.join(self.app_dir, 'config')):
-                            z.write(os.path.join(self.app_dir, 'config', f), os.path.join('config', f))
-                z.close()
+                        for f in os.listdir(path):
+                            if f in ('.indexes', '.max_id'):
+                                continue
+                            z.write(os.path.join(path, f), os.path.join(d, f))
+                    if 'datasources' in self.dirs:
+                        for ds in NamedDataSource.select():
+                            if ds.external == 'agenda':
+                                continue
+                            node = ds.export_to_xml(include_id=True)
+                            misc.indent_xml(node)
+                            z.writestr(
+                                os.path.join('datasources', str(ds.id)),
+                                ET.tostring(node),
+                            )
+                    if 'formdefs' in self.dirs:
+                        for formdef in FormDef.select():
+                            node = formdef.export_to_xml(include_id=True)
+                            misc.indent_xml(node)
+                            z.writestr(
+                                os.path.join('formdefs_xml', str(formdef.id)),
+                                b'<?xml version="1.0"?>\n' + ET.tostring(node),
+                            )
+                    if 'carddefs' in self.dirs:
+                        for formdef in CardDef.select():
+                            node = formdef.export_to_xml(include_id=True)
+                            misc.indent_xml(node)
+                            z.writestr(
+                                os.path.join('carddefs_xml', str(formdef.id)),
+                                b'<?xml version="1.0"?>\n' + ET.tostring(node),
+                            )
+                    if 'workflows' in self.dirs:
+                        for workflow in Workflow.select():
+                            node = workflow.export_to_xml(include_id=True)
+                            misc.indent_xml(node)
+                            z.writestr(
+                                os.path.join('workflows_xml', str(workflow.id)),
+                                b'<?xml version="1.0"?>\n' + ET.tostring(node),
+                            )
+                    if 'blockdefs' in self.dirs:
+                        for blockdef in BlockDef.select():
+                            node = blockdef.export_to_xml(include_id=True)
+                            misc.indent_xml(node)
+                            z.writestr(
+                                os.path.join('blockdefs_xml', str(blockdef.id)),
+                                b'<?xml version="1.0"?>\n' + ET.tostring(node),
+                            )
+                    if 'roles' in self.dirs:
+                        for role in get_publisher().role_class.select():
+                            node = role.export_to_xml(include_id=True)
+                            misc.indent_xml(node)
+                            z.writestr(
+                                os.path.join('roles_xml', str(role.id)),
+                                b'<?xml version="1.0"?>\n' + ET.tostring(node),
+                            )
+
+                    if self.settings:
+                        z.write(os.path.join(self.app_dir, 'config.pck'), 'config.pck')
+                        for f in os.listdir(self.app_dir):
+                            if f.startswith('idp-') and os.path.splitext(f)[-1] in ('.pem', '.xml'):
+                                z.write(os.path.join(self.app_dir, f), f)
+                        if os.path.exists(os.path.join(self.app_dir, 'config')):
+                            for f in os.listdir(os.path.join(self.app_dir, 'config')):
+                                z.write(os.path.join(self.app_dir, 'config', f), os.path.join('config', f))
 
                 job.file_content = c.getvalue()
                 job.store()
diff --git a/wcs/admin/workflows.py b/wcs/admin/workflows.py
index ec0bdba3..f4018bcf 100644
--- a/wcs/admin/workflows.py
+++ b/wcs/admin/workflows.py
@@ -275,10 +275,10 @@ def graphviz(workflow, url_prefix='', select=None, svg=True, include=False):
     out = out.getvalue()
     if svg:
         try:
-            process = Popen(['dot', '-Tsvg'], stdin=PIPE, stdout=PIPE)
-            out = process.communicate(force_bytes(out))[0]
-            if process.returncode != 0:
-                return ''
+            with Popen(['dot', '-Tsvg'], stdin=PIPE, stdout=PIPE) as process:
+                out = process.communicate(force_bytes(out))[0]
+                if process.returncode != 0:
+                    return ''
         except OSError:
             return ''
         out = graphviz_post_treatment(out, revert_colours, include=include)
diff --git a/wcs/backoffice/management.py b/wcs/backoffice/management.py
index c7a8f59a..14068ddc 100644
--- a/wcs/backoffice/management.py
+++ b/wcs/backoffice/management.py
@@ -2997,24 +2997,22 @@ class FormBackOfficeStatusPage(FormStatusPage):
     def download_as_zip(self):
         formdata = self.filled
         zip_content = io.BytesIO()
-        zip_file = zipfile.ZipFile(zip_content, 'w')
         counter = {'value': 0}
 
-        def add_zip_file(upload):
+        def add_zip_file(upload, zip_file):
             counter['value'] += 1
             filename = '%s_%s' % (counter['value'], upload.base_filename)
             zip_file.writestr(filename, upload.get_content())
 
-        for value in formdata.data.values():
-            if isinstance(value, PicklableUpload):
-                add_zip_file(value)
-            if isinstance(value, dict) and isinstance(value.get('data'), list):
-                for subvalue in value.get('data'):
-                    for subvalue_elem in subvalue.values():
-                        if isinstance(subvalue_elem, PicklableUpload):
-                            add_zip_file(subvalue_elem)
-
-        zip_file.close()
+        with zipfile.ZipFile(zip_content, 'w') as zip_file:
+            for value in formdata.data.values():
+                if isinstance(value, PicklableUpload):
+                    add_zip_file(value, zip_file)
+                if isinstance(value, dict) and isinstance(value.get('data'), list):
+                    for subvalue in value.get('data'):
+                        for subvalue_elem in subvalue.values():
+                            if isinstance(subvalue_elem, PicklableUpload):
+                                add_zip_file(subvalue_elem, zip_file)
 
         response = get_response()
         response.set_content_type('application/zip')
diff --git a/wcs/ctl/backup.py b/wcs/ctl/backup.py
index c8d29bfb..a19beabb 100644
--- a/wcs/ctl/backup.py
+++ b/wcs/ctl/backup.py
@@ -48,17 +48,15 @@ class CmdBackup(Command):
                 os.mkdir(backup_dir)
             backup_filepath = os.path.join(backup_dir, 'backup-%s%s%s-%s%s%s.tar.gz' % time.localtime()[:6])
 
-        backup = tarfile.open(backup_filepath, mode='w:gz')
-        for basename, dirnames, filenames in os.walk(pub.app_dir):
-            if 'backups' in dirnames:  # do not recurse in backup directory
-                idx = dirnames.index('backups')
-                dirnames[idx : idx + 1] = []
-            for filename in filenames:
-                backup.add(
-                    os.path.join(basename, filename), os.path.join(basename, filename)[len(pub.app_dir) :]
-                )
-
-        backup.close()
+        with tarfile.open(backup_filepath, mode='w:gz') as backup:
+            for basename, dirnames, filenames in os.walk(pub.app_dir):
+                if 'backups' in dirnames:  # do not recurse in backup directory
+                    idx = dirnames.index('backups')
+                    dirnames[idx : idx + 1] = []
+                for filename in filenames:
+                    backup.add(
+                        os.path.join(basename, filename), os.path.join(basename, filename)[len(pub.app_dir) :]
+                    )
 
 
 CmdBackup.register()
diff --git a/wcs/ctl/management/commands/convert_to_sql.py b/wcs/ctl/management/commands/convert_to_sql.py
index f1b63938..a37543d0 100644
--- a/wcs/ctl/management/commands/convert_to_sql.py
+++ b/wcs/ctl/management/commands/convert_to_sql.py
@@ -100,13 +100,12 @@ class Command(BaseCommand):
         sql.SqlUser.fix_sequences()
 
         if errors:
-            error_log = open('error_user.log', 'w')
-            for user, trace in errors:
-                error_log.write('user_id %s\n' % user.id)
-                error_log.write(trace)
-                error_log.write('-' * 80)
-                error_log.write('\n\n')
-            error_log.close()
+            with open('error_user.log', 'w') as error_log:
+                for user, trace in errors:
+                    error_log.write('user_id %s\n' % user.id)
+                    error_log.write(trace)
+                    error_log.write('-' * 80)
+                    error_log.write('\n\n')
             print('There were some errors, see error_user.log for details.')
 
     def store_forms(self):
@@ -138,15 +137,14 @@ class Command(BaseCommand):
             sql_data_class.fix_sequences()
 
         if errors:
-            error_log = open('error_formdata.log', 'w')
-            for formdata, trace in errors:
-                error_log.write(
-                    '%s %s - %s\n' % (formdata.formdef, formdata.id, localstrftime(formdata.receipt_time))
-                )
-                error_log.write(trace)
-                error_log.write('-' * 80)
-                error_log.write('\n\n')
-            error_log.close()
+            with open('error_formdata.log', 'w') as error_log:
+                for formdata, trace in errors:
+                    error_log.write(
+                        '%s %s - %s\n' % (formdata.formdef, formdata.id, localstrftime(formdata.receipt_time))
+                    )
+                    error_log.write(trace)
+                    error_log.write('-' * 80)
+                    error_log.write('\n\n')
             print('There were some errors, see error_formdata.log.')
 
     def update_progress(self, progress, num_columns=120):
diff --git a/wcs/ctl/restore.py b/wcs/ctl/restore.py
index 94d92381..bc3bcc33 100644
--- a/wcs/ctl/restore.py
+++ b/wcs/ctl/restore.py
@@ -50,12 +50,11 @@ class CmdRestore(Command):
             return 1
         backup_filepath = sub_options.filename
 
-        backup = tarfile.open(backup_filepath, mode='r:*')
-        for tarinfo in backup:
-            if os.path.normpath(tarinfo.name).startswith('..'):
-                continue
-            backup.extract(tarinfo, pub.app_dir)
-        backup.close()
+        with tarfile.open(backup_filepath, mode='r:*') as backup:
+            for tarinfo in backup:
+                if os.path.normpath(tarinfo.name).startswith('..'):
+                    continue
+                backup.extract(tarinfo, pub.app_dir)
 
 
 CmdRestore.register()
diff --git a/wcs/publisher.py b/wcs/publisher.py
index 7072535d..71a0f44a 100644
--- a/wcs/publisher.py
+++ b/wcs/publisher.py
@@ -162,7 +162,6 @@ class WcsPublisher(QommonPublisher):
         self.set_session_manager(self.session_manager_class(session_class=self.session_class))
 
     def import_zip(self, fd):
-        z = zipfile.ZipFile(fd)
         results = {
             'formdefs': 0,
             'carddefs': 0,
@@ -203,129 +202,129 @@ class WcsPublisher(QommonPublisher):
                 rv[key] = value
             return rv
 
-        for f in z.namelist():
-            if f in ('.indexes', '.max_id'):
-                continue
-            if os.path.dirname(f) in (
-                'formdefs_xml',
-                'carddefs_xml',
-                'workflows_xml',
-                'blockdefs_xml',
-                'roles_xml',
-            ):
-                continue
-            path = os.path.join(self.app_dir, f)
-            if not os.path.exists(os.path.dirname(path)):
-                os.mkdir(os.path.dirname(path))
-            if not os.path.basename(f):
-                # skip directories
-                continue
-            data = z.read(f)
-            if f in ('config.pck', 'config.json'):
-                results['settings'] = 1
-                if f == 'config.pck':
-                    d = pickle.loads(data)
-                else:
-                    d = json.loads(force_text(data), object_hook=_decode_dict)
-                if 'sp' in self.cfg:
-                    current_sp = self.cfg['sp']
-                else:
-                    current_sp = None
-                self.cfg = d
-                if current_sp:
-                    self.cfg['sp'] = current_sp
-                elif 'sp' in self.cfg:
-                    del self.cfg['sp']
-                self.write_cfg()
-                continue
-            open(path, 'wb').write(data)
-            if os.path.split(f)[0] in results:
-                results[os.path.split(f)[0]] += 1
-
-        # second pass, fields blocks
-        from wcs.blocks import BlockDef
-
-        for f in z.namelist():
-            if os.path.dirname(f) == 'blockdefs_xml' and os.path.basename(f):
-                blockdef = BlockDef.import_from_xml(z.open(f), include_id=True)
-                blockdef.store()
-                results['blockdefs'] += 1
-
-        # third pass, workflows
-        from wcs.workflows import Workflow
-
-        for f in z.namelist():
-            if os.path.dirname(f) == 'workflows_xml' and os.path.basename(f):
-                workflow = Workflow.import_from_xml(z.open(f), include_id=True, check_datasources=False)
-                workflow.store()
-                results['workflows'] += 1
-
-        # fourth pass, forms and cards
-        from wcs.carddef import CardDef
-        from wcs.formdef import FormDef
-
-        formdefs = []
-        carddefs = []
-        for f in z.namelist():
-            if os.path.dirname(f) == 'formdefs_xml' and os.path.basename(f):
-                formdef = FormDef.import_from_xml(z.open(f), include_id=True, check_datasources=False)
-                formdef.store()
-                formdefs.append(formdef)
-                results['formdefs'] += 1
-            if os.path.dirname(f) == 'carddefs_xml' and os.path.basename(f):
-                carddef = CardDef.import_from_xml(z.open(f), include_id=True, check_datasources=False)
-                carddef.store()
-                carddefs.append(carddef)
-                results['carddefs'] += 1
-
-        # sixth pass, roles
-        roles = []
-        for f in z.namelist():
-            if os.path.dirname(f) == 'roles_xml' and os.path.basename(f):
-                role = self.role_class.import_from_xml(z.open(f), include_id=True)
-                role.store()
-                roles.append(role)
-                results['roles'] += 1
-
-        # rebuild indexes for imported objects
-        for k, v in results.items():
-            if k == 'settings':
-                continue
-            if v == 0:
-                continue
-            klass = None
-            if k == 'formdefs':
-                from .formdef import FormDef
-
-                klass = FormDef
-            elif k == 'carddefs':
-                from .carddef import CardDef
-
-                klass = CardDef
-            elif k == 'blockdefs':
-                klass = BlockDef
-            elif k == 'categories':
-                from .categories import Category
-
-                klass = Category
-            elif k == 'roles':
-                klass = self.role_class
-            elif k == 'workflows':
-                klass = Workflow
-            if klass:
-                klass.rebuild_indexes()
-
-            if k == 'formdefs':
-                # in case of formdefs, we store them anew in case SQL changes
-                # are required.
-                for formdef in formdefs or FormDef.select():
+        with zipfile.ZipFile(fd) as z:
+            for f in z.namelist():
+                if f in ('.indexes', '.max_id'):
+                    continue
+                if os.path.dirname(f) in (
+                    'formdefs_xml',
+                    'carddefs_xml',
+                    'workflows_xml',
+                    'blockdefs_xml',
+                    'roles_xml',
+                ):
+                    continue
+                path = os.path.join(self.app_dir, f)
+                if not os.path.exists(os.path.dirname(path)):
+                    os.mkdir(os.path.dirname(path))
+                if not os.path.basename(f):
+                    # skip directories
+                    continue
+                data = z.read(f)
+                if f in ('config.pck', 'config.json'):
+                    results['settings'] = 1
+                    if f == 'config.pck':
+                        d = pickle.loads(data)
+                    else:
+                        d = json.loads(force_text(data), object_hook=_decode_dict)
+                    if 'sp' in self.cfg:
+                        current_sp = self.cfg['sp']
+                    else:
+                        current_sp = None
+                    self.cfg = d
+                    if current_sp:
+                        self.cfg['sp'] = current_sp
+                    elif 'sp' in self.cfg:
+                        del self.cfg['sp']
+                    self.write_cfg()
+                    continue
+                open(path, 'wb').write(data)
+                if os.path.split(f)[0] in results:
+                    results[os.path.split(f)[0]] += 1
+
+            # second pass, fields blocks
+            from wcs.blocks import BlockDef
+
+            for f in z.namelist():
+                if os.path.dirname(f) == 'blockdefs_xml' and os.path.basename(f):
+                    blockdef = BlockDef.import_from_xml(z.open(f), include_id=True)
+                    blockdef.store()
+                    results['blockdefs'] += 1
+
+            # third pass, workflows
+            from wcs.workflows import Workflow
+
+            for f in z.namelist():
+                if os.path.dirname(f) == 'workflows_xml' and os.path.basename(f):
+                    workflow = Workflow.import_from_xml(z.open(f), include_id=True, check_datasources=False)
+                    workflow.store()
+                    results['workflows'] += 1
+
+            # fourth pass, forms and cards
+            from wcs.carddef import CardDef
+            from wcs.formdef import FormDef
+
+            formdefs = []
+            carddefs = []
+            for f in z.namelist():
+                if os.path.dirname(f) == 'formdefs_xml' and os.path.basename(f):
+                    formdef = FormDef.import_from_xml(z.open(f), include_id=True, check_datasources=False)
                     formdef.store()
-            elif k == 'carddefs':
-                # ditto for cards
-                for carddef in carddefs or CardDef.select():
+                    formdefs.append(formdef)
+                    results['formdefs'] += 1
+                if os.path.dirname(f) == 'carddefs_xml' and os.path.basename(f):
+                    carddef = CardDef.import_from_xml(z.open(f), include_id=True, check_datasources=False)
                     carddef.store()
+                    carddefs.append(carddef)
+                    results['carddefs'] += 1
+
+            # sixth pass, roles
+            roles = []
+            for f in z.namelist():
+                if os.path.dirname(f) == 'roles_xml' and os.path.basename(f):
+                    role = self.role_class.import_from_xml(z.open(f), include_id=True)
+                    role.store()
+                    roles.append(role)
+                    results['roles'] += 1
+
+            # rebuild indexes for imported objects
+            for k, v in results.items():
+                if k == 'settings':
+                    continue
+                if v == 0:
+                    continue
+                klass = None
+                if k == 'formdefs':
+                    from .formdef import FormDef
+
+                    klass = FormDef
+                elif k == 'carddefs':
+                    from .carddef import CardDef
+
+                    klass = CardDef
+                elif k == 'blockdefs':
+                    klass = BlockDef
+                elif k == 'categories':
+                    from .categories import Category
+
+                    klass = Category
+                elif k == 'roles':
+                    klass = self.role_class
+                elif k == 'workflows':
+                    klass = Workflow
+                if klass:
+                    klass.rebuild_indexes()
+
+                if k == 'formdefs':
+                    # in case of formdefs, we store them anew in case SQL changes
+                    # are required.
+                    for formdef in formdefs or FormDef.select():
+                        formdef.store()
+                elif k == 'carddefs':
+                    # ditto for cards
+                    for carddef in carddefs or CardDef.select():
+                        carddef.store()
 
-        z.close()
         return results
 
     def initialize_sql(self):
